commit 43d777078387ab2c4aabe526f6ee0ff13055e0b6
Author: Xi Ruoyao <xry111@xry111.site>
Date:   Sun Mar 2 19:02:50 2025 +0800

    LoongArch: Fix incorrect reorder of __lsx_vldx and __lasx_xvldx [PR119084]
    
    They could be incorrectly reordered with store instructions like st.b
    because the RTL expression does not have a memory_operand or a (mem)
    expression.  The incorrect reorder has been observed in openh264 LTO
    build.
    
    Expand them to a (mem) expression instead of unspec to fix the issue.
    
    Closes: https://github.com/cisco/openh264/issues/3857
    
    (cherry picked from commit 4856292f7a680ec478e7607f1b71781996d7d542)
    
    Edited to remove the loongarch.cc change which is not needed for gcc-14
    branch.
    
    gcc/ChangeLog:
    
            PR target/119084
            * config/loongarch/lasx.md (UNSPEC_LASX_XVLDX): Remove.
            (lasx_xvldx): Remove.
            * config/loongarch/lsx.md (UNSPEC_LSX_VLDX): Remove.
            (lsx_vldx): Remove.
            * config/loongarch/simd.md (QIVEC): New define_mode_iterator.
            (<simd_isa>_<x>vldx): New define_expand.
    
    gcc/testsuite/ChangeLog:
    
            PR target/119084
            * gcc.target/loongarch/pr119084.c: New test.

diff --git a/gcc/testsuite/gcc.target/loongarch/pr119084.c b/gcc/testsuite/gcc.target/loongarch/pr119084.c
new file mode 100644
index 00000000000..b5943303851
--- /dev/null
+++ b/gcc/testsuite/gcc.target/loongarch/pr119084.c
@@ -0,0 +1,24 @@
+/* { dg-do run } */
+/* { dg-options "-O2 -mlsx" } */
+/* { dg-require-effective-target loongarch_sx_hw } */
+
+typedef signed char V16QI __attribute__ ((vector_size (16)));
+static char x[128];
+
+__attribute__ ((noipa)) int
+noopt (int x)
+{
+  return x;
+}
+
+int
+main (void)
+{
+  int t = noopt (32);
+
+  x[32] = 1;
+
+  V16QI y = __builtin_lsx_vldx (x, t);
+  if (y[0] != 1)
+    __builtin_trap ();
+}

